com.fasterxml.jackson.core.json

## Class WriterBasedJsonGenerator

- java.lang.Object
- - com.fasterxml.jackson.core.JsonGenerator
  - - com.fasterxml.jackson.core.base.GeneratorBase
    - - com.fasterxml.jackson.core.json.JsonGeneratorImpl
      - - com.fasterxml.jackson.core.json.WriterBasedJsonGenerator

All Implemented Interfaces:
  Versioned, Closeable, Flushable, AutoCloseable

    public class WriterBasedJsonGenerator
    extends JsonGeneratorImpl

`JsonGenerator` that outputs JSON content using a `Writer` which handles character encoding.

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonGenerator

`JsonGenerator.Feature`

### Field Summary

Fields
`protected char[]` `_copyBuffer` Intermediate buffer in which characters of a String are copied before being encoded.
`protected SerializableString` `_currentEscape` When custom escapes are used, this member variable is used internally to hold a reference to currently used escape
`protected char[]` `_entityBuffer` Short (14 char) temporary buffer allocated if needed, for constructing escape sequences
`protected char[]` `_outputBuffer` Intermediate buffer in which contents are buffered before being written using `_writer`.
`protected int` `_outputEnd` End marker of the output buffer; one past the last valid position within the buffer.
`protected int` `_outputHead` Pointer to the first buffered character to output
`protected int` `_outputTail` Pointer to the position right beyond the last character to output (end marker; may point to position right beyond the end of the buffer)
`protected char` `_quoteChar` Character used for quoting JSON Object property names and String values.
`protected Writer` `_writer`
`protected static char[]` `HEX_CHARS_LOWER`
`protected static char[]` `HEX_CHARS_UPPER`
`protected static int` `SHORT_WRITE`

### Fields inherited from class com.fasterxml.jackson.core.json.JsonGeneratorImpl

`_cfgUnqNames, _cfgWriteHexUppercase, _characterEscapes, _maximumNonEscapedChar, _outputEscapes, _rootValueSeparator, _streamWriteConstraints, JSON_WRITE_CAPABILITIES, sOutputEscapes`

### Fields inherited from class com.fasterxml.jackson.core.base.GeneratorBase

`_cfgNumbersAsStrings, _closed, _features, _ioContext, _objectCodec, _writeContext, DERIVED_FEATURES_MASK, MAX_BIG_DECIMAL_SCALE, SURR1_FIRST, SURR1_LAST, SURR2_FIRST, SURR2_LAST, WRITE_BINARY, WRITE_BOOLEAN, WRITE_NULL, WRITE_NUMBER, WRITE_RAW, WRITE_STRING`

### Fields inherited from class com.fasterxml.jackson.core.JsonGenerator

`_cfgPrettyPrinter, DEFAULT_BINARY_WRITE_CAPABILITIES, DEFAULT_TEXTUAL_WRITE_CAPABILITIES, DEFAULT_WRITE_CAPABILITIES`

### Constructor Summary

Constructors
Constructor and Description
`WriterBasedJsonGenerator(IOContext ctxt, int features, ObjectCodec codec, Writer w)` Deprecated.
`WriterBasedJsonGenerator(IOContext ctxt, int features, ObjectCodec codec, Writer w, char quoteChar)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `_flushBuffer()`
`protected void` `_releaseBuffers()` Method called to release any buffers generator may be holding, once generator is being closed.
`protected void` `_verifyValueWrite(String typeMsg)` Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.
`protected void` `_writeBinary(Base64Variant b64variant, byte[] input, int inputPtr, int inputEnd)`
`protected int` `_writeBinary(Base64Variant b64variant, InputStream data, byte[] readBuffer)`
`protected int` `_writeBinary(Base64Variant b64variant, InputStream data, byte[] readBuffer, int bytesLeft)`
`protected void` `_writeFieldName(SerializableString name, boolean commaBefore)`
`protected void` `_writeFieldName(String name, boolean commaBefore)`
`protected void` `_writePPFieldName(SerializableString name, boolean commaBefore)`
`protected void` `_writePPFieldName(String name, boolean commaBefore)`
`boolean` `canWriteFormattedNumbers()` Introspection method to call to check whether it is possible to write numbers using `JsonGenerator.writeNumber(java.lang.String)` using possible custom format, or not.
`void` `close()` Method called to close this generator, so that no more content can be written.
`void` `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
`int` `getOutputBuffered()` Method for verifying amount of content that is buffered by generator but not yet flushed to the underlying target (stream, writer), in units (byte, char) that the generator implementation uses for buffering; or -1 if this information is not available.
`Object` `getOutputTarget()` Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with.
`void` `writeBinary(Base64Variant b64variant, byte[] data, int offset, int len)` Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes).
`int` `writeBinary(Base64Variant b64variant, InputStream data, int dataLength)` Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
`void` `writeBoolean(boolean state)` Method for outputting literal JSON boolean value (one of Strings 'true' and 'false').
`void` `writeEndArray()` Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).
`void` `writeEndObject()` Method for writing closing marker of an Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).
`void` `writeFieldName(SerializableString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
`void` `writeFieldName(String name)` Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.
`void` `writeNull()` Method for outputting literal JSON null value.
`void` `writeNumber(BigDecimal value)` Method for outputting indicate JSON numeric value.
`void` `writeNumber(BigInteger value)` Method for outputting given value as JSON number.
`void` `writeNumber(char[] encodedValueBuffer, int offset, int length)` Overloaded version of `JsonGenerator.writeNumber(String)` with same semantics but possibly more efficient operation.
`void` `writeNumber(double d)` Method for outputting indicate JSON numeric value.
`void` `writeNumber(float f)` Method for outputting indicate JSON numeric value.
`void` `writeNumber(int i)` Method for outputting given value as JSON number.
`void` `writeNumber(long l)` Method for outputting given value as JSON number.
`void` `writeNumber(short s)` Method for outputting given value as JSON number.
`void` `writeNumber(String encodedValue)` Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types.
`void` `writeRaw(char c)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRaw(char[] cbuf, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRaw(SerializableString text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRaw(String text)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRaw(String text, int offset, int len)` Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such).
`void` `writeRawUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON).
`void` `writeStartArray()` Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).
`void` `writeStartArray(Object currentValue)` Method for writing start marker of an Array value, similar to `JsonGenerator.writeStartArray()`, but also specifying the "current value" to assign to the new Array context being created.
`void` `writeStartArray(Object currentValue, int size)` Method for writing start marker of an Array value, similar to `JsonGenerator.writeStartArray()`, but also specifying the "current value" to assign to the new Array context being created as well as how many elements will be written for the array before calling `JsonGenerator.writeEndArray()`.
`void` `writeStartObject()` Method for writing starting marker of an Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).
`void` `writeStartObject(Object forValue)` Method for writing starting marker of an Object value to represent the given Java Object value.
`void` `writeStartObject(Object forValue, int size)` Method for writing starting marker of an Object value to represent the given Java Object value.
`void` `writeString(char[] text, int offset, int len)` Method for outputting a String value.
`void` `writeString(Reader reader, int len)` Method for outputting a String value.
`void` `writeString(SerializableString sstr)` Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
`void` `writeString(String text)` Method for outputting a String value.
`void` `writeUTF8String(byte[] text, int offset, int length)` Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else).

### Methods inherited from class com.fasterxml.jackson.core.json.JsonGeneratorImpl

`_checkStdFeatureChanges, _reportCantWriteValueExpectName, _verifyPrettyValueWrite, disable, enable, getCharacterEscapes, getHighestEscapedChar, getWriteCapabilities, ioContext, setCharacterEscapes, setHighestNonEscapedChar, setRootValueSeparator, streamWriteConstraints, version`

### Methods inherited from class com.fasterxml.jackson.core.base.GeneratorBase

`_asString, _checkRangeBoundsForByteArray, _checkRangeBoundsForCharArray, _checkRangeBoundsForString, _constructDefaultPrettyPrinter, _decodeSurrogate, getCodec, getCurrentValue, getFeatureMask, getOutputContext, isClosed, isEnabled, overrideStdFeatures, setCodec, setCurrentValue, setFeatureMask, useDefaultPrettyPrinter, writeObject, writeRawValue, writeRawValue, writeRawValue, writeRawValue, writeTree`

### Methods inherited from class com.fasterxml.jackson.core.JsonGenerator

`_copyCurrentContents, _copyCurrentFloatValue, _copyCurrentFloatValueExact, _copyCurrentIntValue, _copyCurrentStringValue, _reportError, _reportUnsupportedOperation, _throwInternal, _verifyOffsets, _writeSimpleObject, assignCurrentValue, canOmitFields, canUseSchema, canWriteBinaryNatively, canWriteObjectId, canWriteTypeId, configure, copyCurrentEvent, copyCurrentEventExact, copyCurrentStructure, currentValue, getFormatFeatures, getPrettyPrinter, getSchema, isEnabled, overrideFormatFeatures, setPrettyPrinter, setSchema, writeArray, writeArray, writeArray, writeArray, writeArrayFieldStart, writeBinary, writeBinary, writeBinary, writeBinaryField, writeBooleanField, writeEmbeddedObject, writeFieldId, writeNullField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart, writeObjectId, writeObjectRef, writeOmittedField, writePOJO, writePOJOField, writeStartArray, writeStringField, writeTypeId, writeTypePrefix, writeTypeSuffix`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### SHORT_WRITE

    protected static final int SHORT_WRITE

See Also:
  Constant Field Values

#### HEX_CHARS_UPPER

    protected static final char[] HEX_CHARS_UPPER

#### HEX_CHARS_LOWER

    protected static final char[] HEX_CHARS_LOWER

#### _writer

    protected final Writer _writer

#### _quoteChar

    protected char _quoteChar

Character used for quoting JSON Object property names and String values.

#### _outputBuffer

    protected char[] _outputBuffer

Intermediate buffer in which contents are buffered before being written using `_writer`.

#### _outputHead

    protected int _outputHead

Pointer to the first buffered character to output

#### _outputTail

    protected int _outputTail

Pointer to the position right beyond the last character to output (end marker; may point to position right beyond the end of the buffer)

#### _outputEnd

    protected int _outputEnd

End marker of the output buffer; one past the last valid position within the buffer.

#### _entityBuffer

    protected char[] _entityBuffer

Short (14 char) temporary buffer allocated if needed, for constructing escape sequences

#### _currentEscape

    protected SerializableString _currentEscape

When custom escapes are used, this member variable is used internally to hold a reference to currently used escape

#### _copyBuffer

    protected char[] _copyBuffer

Intermediate buffer in which characters of a String are copied before being encoded.

Since:
  2.10

### Constructor Detail

#### WriterBasedJsonGenerator

    @Deprecated
    public WriterBasedJsonGenerator(IOContext ctxt,
                                                int features,
                                                ObjectCodec codec,
                                                Writer w)

Deprecated.

#### WriterBasedJsonGenerator

    public WriterBasedJsonGenerator(IOContext ctxt,
                                    int features,
                                    ObjectCodec codec,
                                    Writer w,
                                    char quoteChar)

### Method Detail

#### getOutputTarget

    public Object getOutputTarget()

Description copied from class: `JsonGenerator`
Method that can be used to get access to object that is used as target for generated output; this is usually either `OutputStream` or `Writer`, depending on what generator was constructed with. Note that returned value may be null in some cases; including case where implementation does not want to exposed raw source to caller. In cases where output has been decorated, object returned here is the decorated version; this allows some level of interaction between users of generator and decorator object.

In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

Overrides:
  `getOutputTarget` in class `JsonGenerator`
Returns:
  Output target this generator was configured with

#### getOutputBuffered

    public int getOutputBuffered()

Description copied from class: `JsonGenerator`
Method for verifying amount of content that is buffered by generator but not yet flushed to the underlying target (stream, writer), in units (byte, char) that the generator implementation uses for buffering; or -1 if this information is not available. Unit used is often the same as the unit of underlying target (that is, `byte` for `OutputStream`, `char` for `Writer`), but may differ if buffering is done before encoding. Default JSON-backed implementations do use matching units.

Note: non-JSON implementations will be retrofitted for 2.6 and beyond; please report if you see -1 (missing override)

Overrides:
  `getOutputBuffered` in class `JsonGenerator`
Returns:
  Amount of content buffered in internal units, if amount known and accessible; -1 if not accessible.

#### canWriteFormattedNumbers

    public boolean canWriteFormattedNumbers()

Description copied from class: `JsonGenerator`
Introspection method to call to check whether it is possible to write numbers using `JsonGenerator.writeNumber(java.lang.String)` using possible custom format, or not. Typically textual formats allow this (and JSON specifically does), whereas binary formats do not allow this (except by writing them as Strings). Usual reason for calling this method is to check whether custom formatting of numbers may be applied by higher-level code (databinding) or not.

Overrides:
  `canWriteFormattedNumbers` in class `JsonGenerator`
Returns:
  `True` if this generator is capable of writing "formatted" numbers (and if so, need to be passed using `JsonGenerator.writeNumber(String)`, that is, passed as `String`); `false` if not

#### writeFieldName

    public void writeFieldName(String name)
                        throws IOException

Description copied from class: `JsonGenerator`
Method for writing a field name (JSON String surrounded by double quotes: syntactically identical to a JSON String value), possibly decorated by white space if pretty-printing is enabled.

Field names can only be written in Object context (check out JSON specification for details), when field name is expected (field names alternate with values).

Specified by:
  `writeFieldName` in class `JsonGenerator`
Parameters:
  `name` - Field name to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeFieldName

    public void writeFieldName(SerializableString name)
                        throws IOException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

Overrides:
  `writeFieldName` in class `GeneratorBase`
Parameters:
  `name` - Field name to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### _writeFieldName

    protected final void _writeFieldName(String name,
                                         boolean commaBefore)
                                  throws IOException

Throws:
  `IOException`

#### _writeFieldName

    protected final void _writeFieldName(SerializableString name,
                                         boolean commaBefore)
                                  throws IOException

Throws:
  `IOException`

#### writeStartArray

    public void writeStartArray()
                         throws IOException

Description copied from class: `JsonGenerator`
Method for writing starting marker of a Array value (for JSON this is character '['; plus possible white space decoration if pretty-printing is enabled).

Array values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

Specified by:
  `writeStartArray` in class `JsonGenerator`
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeStartArray

    public void writeStartArray(Object currentValue)
                         throws IOException

Description copied from class: `JsonGenerator`
Method for writing start marker of an Array value, similar to `JsonGenerator.writeStartArray()`, but also specifying the "current value" to assign to the new Array context being created.

Overrides:
  `writeStartArray` in class `JsonGenerator`
Parameters:
  `currentValue` - "Current value" to assign for the Array context being created
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeStartArray

    public void writeStartArray(Object currentValue,
                                int size)
                         throws IOException

Description copied from class: `JsonGenerator`
Method for writing start marker of an Array value, similar to `JsonGenerator.writeStartArray()`, but also specifying the "current value" to assign to the new Array context being created as well as how many elements will be written for the array before calling `JsonGenerator.writeEndArray()`.

Overrides:
  `writeStartArray` in class `JsonGenerator`
Parameters:
  `currentValue` - "Current value" to assign for the Array context being created
  `size` - Number of elements this Array will have: actual number of values written (before matching call to `JsonGenerator.writeEndArray()` MUST match; generator MAY verify this is the case (and SHOULD if format itself encodes length)
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeEndArray

    public void writeEndArray()
                       throws IOException

Description copied from class: `JsonGenerator`
Method for writing closing marker of a JSON Array value (character ']'; plus possible white space decoration if pretty-printing is enabled).

Marker can be written if the innermost structured type is Array.

Specified by:
  `writeEndArray` in class `JsonGenerator`
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeStartObject

    public void writeStartObject()
                          throws IOException

Description copied from class: `JsonGenerator`
Method for writing starting marker of an Object value (character '{'; plus possible white space decoration if pretty-printing is enabled).

Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

Specified by:
  `writeStartObject` in class `JsonGenerator`
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeStartObject

    public void writeStartObject(Object forValue)
                          throws IOException

Description copied from class: `JsonGenerator`
Method for writing starting marker of an Object value to represent the given Java Object value. Argument is offered as metadata, but more importantly it should be assigned as the "current value" for the Object content that gets constructed and initialized.

Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

Overrides:
  `writeStartObject` in class `GeneratorBase`
Parameters:
  `forValue` - "Current value" to assign for the Object context being created
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeStartObject

    public void writeStartObject(Object forValue,
                                 int size)
                          throws IOException

Description copied from class: `JsonGenerator`
Method for writing starting marker of an Object value to represent the given Java Object value. Argument is offered as metadata, but more importantly it should be assigned as the "current value" for the Object content that gets constructed and initialized. In addition, caller knows number of key/value pairs ("properties") that will get written for the Object value: this is relevant for some format backends (but not, as an example, for JSON).

Object values can be written in any context where values are allowed: meaning everywhere except for when a field name is expected.

Overrides:
  `writeStartObject` in class `JsonGenerator`
Parameters:
  `forValue` - "Current value" to assign for the Object context being created
  `size` - Number of key/value pairs this Object will have: actual number of entries written (before matching call to `JsonGenerator.writeEndObject()` MUST match; generator MAY verify this is the case (and SHOULD if format itself encodes length)
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeEndObject

    public void writeEndObject()
                        throws IOException

Description copied from class: `JsonGenerator`
Method for writing closing marker of an Object value (character '}'; plus possible white space decoration if pretty-printing is enabled).

Marker can be written if the innermost structured type is Object, and the last written event was either a complete value, or START-OBJECT marker (see JSON specification for more details).

Specified by:
  `writeEndObject` in class `JsonGenerator`
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### _writePPFieldName

    protected final void _writePPFieldName(String name,
                                           boolean commaBefore)
                                    throws IOException

Throws:
  `IOException`

#### _writePPFieldName

    protected final void _writePPFieldName(SerializableString name,
                                           boolean commaBefore)
                                    throws IOException

Throws:
  `IOException`

#### writeString

    public void writeString(String text)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.

Specified by:
  `writeString` in class `JsonGenerator`
Parameters:
  `text` - Text value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeString

    public void writeString(Reader reader,
                            int len)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification. If `len` is < 0, then write all contents of the reader. Otherwise, write only len characters.

Note: actual length of content available may exceed `len` but can not be less than it: if not enough content available, a `JsonGenerationException` will be thrown.

Overrides:
  `writeString` in class `JsonGenerator`
Parameters:
  `reader` - Reader to use for reading Text value to write
  `len` - Maximum Length of Text value to read (in `char`s, non-negative) if known; `-1` to indicate "read and write it all"
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer; or if length (`len`) is specified but `reader` does not provide enough content

#### writeString

    public void writeString(char[] text,
                            int offset,
                            int len)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting a String value. Depending on context this means either array element, (object) field value or a stand alone String; but in all cases, String will be surrounded in double quotes, and contents will be properly escaped as required by JSON specification.

Specified by:
  `writeString` in class `JsonGenerator`
Parameters:
  `text` - Buffer that contains String value to write
  `offset` - Offset in `buffer` of the first character of String value to write
  `len` - Length of the String value (in characters) to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeString

    public void writeString(SerializableString sstr)
                     throws IOException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

Overrides:
  `writeString` in class `GeneratorBase`
Parameters:
  `sstr` - Pre-encoded String value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeRawUTF8String

    public void writeRawUTF8String(byte[] text,
                                   int offset,
                                   int length)
                            throws IOException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String that is to be output as-is, without additional escaping (type of which depends on data format; backslashes for JSON). However, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. If so, implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

Specified by:
  `writeRawUTF8String` in class `JsonGenerator`
Parameters:
  `text` - Buffer that contains String value to write
  `offset` - Offset in `buffer` of the first byte of String value to write
  `length` - Length of the String value (in characters) to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeUTF8String

    public void writeUTF8String(byte[] text,
                                int offset,
                                int length)
                         throws IOException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeString(String)` but that takes as its input a UTF-8 encoded String which has not been escaped using whatever escaping scheme data format requires (for JSON that is backslash-escaping for control characters and double-quotes; for other formats something else). This means that textual JSON backends need to check if value needs JSON escaping, but otherwise can just be copied as is to output. Also, quoting that data format requires (like double-quotes for JSON) will be added around the value if and as necessary.

Note that some backends may choose not to support this method: for example, if underlying destination is a `Writer` using this method would require UTF-8 decoding. In this case generator implementation may instead choose to throw a `UnsupportedOperationException` due to ineffectiveness of having to decode input.

Specified by:
  `writeUTF8String` in class `JsonGenerator`
Parameters:
  `text` - Buffer that contains String value to write
  `offset` - Offset in `buffer` of the first byte of String value to write
  `length` - Length of the String value (in characters) to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeRaw

    public void writeRaw(String text)
                  throws IOException

Description copied from class: `JsonGenerator`
Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

Specified by:
  `writeRaw` in class `JsonGenerator`
Parameters:
  `text` - Textual contents to include as-is in output.
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeRaw

    public void writeRaw(String text,
                         int offset,
                         int len)
                  throws IOException

Description copied from class: `JsonGenerator`
Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

Specified by:
  `writeRaw` in class `JsonGenerator`
Parameters:
  `text` - String that has contents to include as-is in output
  `offset` - Offset within `text` of the first character to output
  `len` - Length of content (from `text`, starting at offset `offset`) to output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeRaw

    public void writeRaw(SerializableString text)
                  throws IOException

Description copied from class: `JsonGenerator`
Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

The default implementation delegates to `JsonGenerator.writeRaw(String)`; other backends that support raw inclusion of text are encouraged to implement it in more efficient manner (especially if they use UTF-8 encoding).

Overrides:
  `writeRaw` in class `JsonGenerator`
Parameters:
  `text` - Pre-encoded textual contents to included in output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeRaw

    public void writeRaw(char[] cbuf,
                         int offset,
                         int len)
                  throws IOException

Description copied from class: `JsonGenerator`
Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

Specified by:
  `writeRaw` in class `JsonGenerator`
Parameters:
  `cbuf` - Buffer that has contents to include as-is in output
  `offset` - Offset within `text` of the first character to output
  `len` - Length of content (from `text`, starting at offset `offset`) to output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeRaw

    public void writeRaw(char c)
                  throws IOException

Description copied from class: `JsonGenerator`
Method that will force generator to copy input text verbatim with no modifications (including that no escaping is done and no separators are added even if context [array, object] would otherwise require such). If such separators are desired, use `JsonGenerator.writeRawValue(String)` instead.

Note that not all generator implementations necessarily support such by-pass methods: those that do not will throw `UnsupportedOperationException`.

Specified by:
  `writeRaw` in class `JsonGenerator`
Parameters:
  `c` - Character to included in output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeBinary

    public void writeBinary(Base64Variant b64variant,
                            byte[] data,
                            int offset,
                            int len)
                     throws IOException,
                            JsonGenerationException

Description copied from class: `JsonGenerator`
Method that will output given chunk of binary data as base64 encoded, as a complete String value (surrounded by double quotes). This method defaults

Note: because JSON Strings can not contain unescaped linefeeds, if linefeeds are included (as per last argument), they must be escaped. This adds overhead for decoding without improving readability. Alternatively if linefeeds are not included, resulting String value may violate the requirement of base64 RFC which mandates line-length of 76 characters and use of linefeeds. However, all `JsonParser` implementations are required to accept such "long line base64"; as do typical production-level base64 decoders.

Specified by:
  `writeBinary` in class `JsonGenerator`
Parameters:
  `b64variant` - Base64 variant to use: defines details such as whether padding is used (and if so, using which character); what is the maximum line length before adding linefeed, and also the underlying alphabet to use.
  `data` - Buffer that contains binary data to write
  `offset` - Offset in `data` of the first byte of data to write
  `len` - Length of data to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer
  `JsonGenerationException`

#### writeBinary

    public int writeBinary(Base64Variant b64variant,
                           InputStream data,
                           int dataLength)
                    throws IOException,
                           JsonGenerationException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.

Overrides:
  `writeBinary` in class `GeneratorBase`
Parameters:
  `b64variant` - Base64 variant to use
  `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
  `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. If a positive length is given, `data` MUST provide at least that many bytes: if not, an exception will be thrown. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may.
Returns:
  Number of bytes read from `data` and written as binary payload
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer
  `JsonGenerationException`

#### writeNumber

    public void writeNumber(short s)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Overrides:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `s` - Number value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNumber

    public void writeNumber(int i)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Specified by:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `i` - Number value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNumber

    public void writeNumber(long l)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Specified by:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `l` - Number value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNumber

    public void writeNumber(BigInteger value)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting given value as JSON number. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Specified by:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `value` - Number value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNumber

    public void writeNumber(double d)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Specified by:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `d` - Number value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNumber

    public void writeNumber(float f)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Specified by:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `f` - Number value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNumber

    public void writeNumber(BigDecimal value)
                     throws IOException

Description copied from class: `JsonGenerator`
Method for outputting indicate JSON numeric value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Specified by:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `value` - Number value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNumber

    public void writeNumber(String encodedValue)
                     throws IOException

Description copied from class: `JsonGenerator`
Write method that can be used for custom numeric types that can not be (easily?) converted to "standard" Java number types. Because numbers are not surrounded by double quotes, regular `JsonGenerator.writeString(java.lang.String)` method can not be used; nor `JsonGenerator.writeRaw(java.lang.String)` because that does not properly handle value separators needed in Array or Object contexts.

Note: because of lack of type safety, some generator implementations may not be able to implement this method. For example, if a binary JSON format is used, it may require type information for encoding; similarly for generator-wrappers around Java objects or JSON nodes. If implementation does not implement this method, it needs to throw `UnsupportedOperationException`.

Specified by:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `encodedValue` - Textual (possibly format) number representation to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNumber

    public void writeNumber(char[] encodedValueBuffer,
                            int offset,
                            int length)
                     throws IOException

Description copied from class: `JsonGenerator`
Overloaded version of `JsonGenerator.writeNumber(String)` with same semantics but possibly more efficient operation.

Overrides:
  `writeNumber` in class `JsonGenerator`
Parameters:
  `encodedValueBuffer` - Buffer that contains the textual number representation to write
  `offset` - Offset of the first character of value to write
  `length` - Length of the value (in characters) to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeBoolean

    public void writeBoolean(boolean state)
                      throws IOException

Description copied from class: `JsonGenerator`
Method for outputting literal JSON boolean value (one of Strings 'true' and 'false'). Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Specified by:
  `writeBoolean` in class `JsonGenerator`
Parameters:
  `state` - Boolean value to write
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### writeNull

    public void writeNull()
                   throws IOException

Description copied from class: `JsonGenerator`
Method for outputting literal JSON null value. Can be called in any context where a value is expected (Array value, Object field value, root-level value). Additional white space may be added around the value if pretty-printing is enabled.

Specified by:
  `writeNull` in class `JsonGenerator`
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### _verifyValueWrite

    protected final void _verifyValueWrite(String typeMsg)
                                    throws IOException

Description copied from class: `GeneratorBase`
Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.

Specified by:
  `_verifyValueWrite` in class `GeneratorBase`
Parameters:
  `typeMsg` - Additional message used for generating exception message if value output is NOT legal in current generator output state.
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### flush

    public void flush()
               throws IOException

Description copied from class: `JsonGenerator`
Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.

Specified by:
  `flush` in interface `Flushable`
Specified by:
  `flush` in class `GeneratorBase`
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

#### close

    public void close()
               throws IOException

Description copied from class: `JsonGenerator`
Method called to close this generator, so that no more content can be written.

Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Overrides:
  `close` in class `GeneratorBase`
Throws:
  `IOException` - if there is either an underlying I/O problem

#### _releaseBuffers

    protected void _releaseBuffers()

Description copied from class: `GeneratorBase`
Method called to release any buffers generator may be holding, once generator is being closed.

Specified by:
  `_releaseBuffers` in class `GeneratorBase`

#### _writeBinary

    protected final void _writeBinary(Base64Variant b64variant,
                                      byte[] input,
                                      int inputPtr,
                                      int inputEnd)
                               throws IOException,
                                      JsonGenerationException

Throws:
  `IOException`
  `JsonGenerationException`

#### _writeBinary

    protected final int _writeBinary(Base64Variant b64variant,
                                     InputStream data,
                                     byte[] readBuffer,
                                     int bytesLeft)
                              throws IOException,
                                     JsonGenerationException

Throws:
  `IOException`
  `JsonGenerationException`

#### _writeBinary

    protected final int _writeBinary(Base64Variant b64variant,
                                     InputStream data,
                                     byte[] readBuffer)
                              throws IOException,
                                     JsonGenerationException

Throws:
  `IOException`
  `JsonGenerationException`

#### _flushBuffer

    protected void _flushBuffer()
                         throws IOException

Throws:
  `IOException`